From 3273a5fb9b966d164055cdf757addb1dfc8c97ac Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 22 2020 23:51:43 +0000
Subject: [PATCH 327/2232] Merge pull request #133 from dtolnay/lifetimes


Trigger error on explicitly specified lifetimes in a reference type
---

diff --git a/syntax/check.rs b/syntax/check.rs
index 3b6937a..fa51ed3 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -1,5 +1,7 @@
 use crate::syntax::atom::Atom::{self, *};
-use crate::syntax::{error, ident, Api, ExternFn, Lang, Ref, Slice, Struct, Ty1, Type, Types};
+use crate::syntax::{
+    error, ident, Api, ExternFn, Lang, Receiver, Ref, Slice, Struct, Ty1, Type, Types,
+};
 use proc_macro2::{Delimiter, Group, Ident, TokenStream};
 use quote::{quote, ToTokens};
 use std::fmt::Display;
@@ -100,6 +102,10 @@ fn check_type_unique_ptr(cx: &mut Check, ptr: &Ty1) {
 }
 
 fn check_type_ref(cx: &mut Check, ty: &Ref) {
+    if ty.lifetime.is_some() {
+        cx.error(ty, "references with explicit lifetimes are not supported");
+    }
+
     match ty.inner {
         Type::Fn(_) | Type::Void(_) => {}
         _ => return,
@@ -134,6 +140,13 @@ fn check_api_struct(cx: &mut Check, strct: &Struct) {
 }
 
 fn check_api_fn(cx: &mut Check, efn: &ExternFn) {
+    if let Some(receiver) = &efn.receiver {
+        if receiver.lifetime.is_some() {
+            let span = span_for_receiver_error(receiver);
+            cx.error(span, "references with explicit lifetimes are not supported");
+        }
+    }
+
     for arg in &efn.args {
         if is_unsized(cx, &arg.ty) {
             let desc = describe(cx, &arg.ty);
@@ -223,6 +236,19 @@ fn span_for_struct_error(strct: &Struct) -> TokenStream {
     quote!(#struct_token #brace_token)
 }
 
+fn span_for_receiver_error(receiver: &Receiver) -> TokenStream {
+    let ampersand = receiver.ampersand;
+    let lifetime = &receiver.lifetime;
+    let mutability = receiver.mutability;
+    if receiver.shorthand {
+        let var = receiver.var;
+        quote!(#ampersand #lifetime #mutability #var)
+    } else {
+        let ty = &receiver.ty;
+        quote!(#ampersand #lifetime #mutability #ty)
+    }
+}
+
 fn combine_errors(errors: Vec<Error>) -> Result<()> {
     let mut iter = errors.into_iter();
     let mut all_errors = match iter.next() {
diff --git a/syntax/impls.rs b/syntax/impls.rs
index 7b2d746..acc99ab 100644
--- a/syntax/impls.rs
+++ b/syntax/impls.rs
@@ -86,15 +86,17 @@ impl PartialEq for Ref {
     fn eq(&self, other: &Ref) -> bool {
         let Ref {
             ampersand: _,
+            lifetime,
             mutability,
             inner,
         } = self;
         let Ref {
             ampersand: _,
+            lifetime: lifetime2,
             mutability: mutability2,
             inner: inner2,
         } = other;
-        mutability.is_some() == mutability2.is_some() && inner == inner2
+        lifetime == lifetime2 && mutability.is_some() == mutability2.is_some() && inner == inner2
     }
 }
 
@@ -102,9 +104,11 @@ impl Hash for Ref {
     fn hash<H: Hasher>(&self, state: &mut H) {
         let Ref {
             ampersand: _,
+            lifetime,
             mutability,
             inner,
         } = self;
+        lifetime.hash(state);
         mutability.is_some().hash(state);
         inner.hash(state);
     }
@@ -186,17 +190,21 @@ impl PartialEq for Receiver {
     fn eq(&self, other: &Receiver) -> bool {
         let Receiver {
             ampersand: _,
+            lifetime,
             mutability,
             var: _,
             ty,
+            shorthand: _,
         } = self;
         let Receiver {
             ampersand: _,
+            lifetime: lifetime2,
             mutability: mutability2,
             var: _,
             ty: ty2,
+            shorthand: _,
         } = other;
-        mutability.is_some() == mutability2.is_some() && ty == ty2
+        lifetime == lifetime2 && mutability.is_some() == mutability2.is_some() && ty == ty2
     }
 }
 
@@ -204,10 +212,13 @@ impl Hash for Receiver {
     fn hash<H: Hasher>(&self, state: &mut H) {
         let Receiver {
             ampersand: _,
+            lifetime,
             mutability,
             var: _,
             ty,
+            shorthand: _,
         } = self;
+        lifetime.hash(state);
         mutability.is_some().hash(state);
         ty.hash(state);
     }
diff --git a/syntax/mod.rs b/syntax/mod.rs
index 3a2bb93..ab5cecc 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -19,7 +19,7 @@ use self::parse::kw;
 use proc_macro2::{Ident, Span};
 use syn::punctuated::Punctuated;
 use syn::token::{Brace, Bracket, Paren};
-use syn::{LitStr, Token};
+use syn::{Lifetime, LitStr, Token};
 
 pub use self::atom::Atom;
 pub use self::doc::Doc;
@@ -76,9 +76,11 @@ pub struct Var {
 
 pub struct Receiver {
     pub ampersand: Token![&],
+    pub lifetime: Option<Lifetime>,
     pub mutability: Option<Token![mut]>,
     pub var: Token![self],
     pub ty: Ident,
+    pub shorthand: bool,
 }
 
 pub enum Type {
@@ -102,6 +104,7 @@ pub struct Ty1 {
 
 pub struct Ref {
     pub ampersand: Token![&],
+    pub lifetime: Option<Lifetime>,
     pub mutability: Option<Token![mut]>,
     pub inner: Type,
 }
diff --git a/syntax/parse.rs b/syntax/parse.rs
index 8cc4e2a..bdccbda 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -177,12 +177,14 @@ fn parse_extern_fn(
         match arg {
             FnArg::Receiver(arg) => {
                 if let Some(ety) = single_type {
-                    if let Some((ampersand, _)) = arg.reference {
+                    if let Some((ampersand, lifetime)) = &arg.reference {
                         receiver = Some(Receiver {
-                            ampersand,
+                            ampersand: *ampersand,
+                            lifetime: lifetime.clone(),
                             mutability: arg.mutability,
-                            var: Token![self](ety.ident.span()),
+                            var: arg.self_token,
                             ty: ety.ident.clone(),
+                            shorthand: true,
                         });
                         continue;
                     }
@@ -206,9 +208,11 @@ fn parse_extern_fn(
                     if let Type::Ident(ident) = reference.inner {
                         receiver = Some(Receiver {
                             ampersand: reference.ampersand,
+                            lifetime: reference.lifetime,
                             mutability: reference.mutability,
                             var: Token![self](ident.span()),
                             ty: ident,
+                            shorthand: false,
                         });
                         continue;
                     }
@@ -273,6 +277,7 @@ fn parse_type_reference(ty: &TypeReference) -> Result<Type> {
     };
     Ok(which(Box::new(Ref {
         ampersand: ty.and_token,
+        lifetime: ty.lifetime.clone(),
         mutability: ty.mutability,
         inner,
     })))
diff --git a/syntax/tokens.rs b/syntax/tokens.rs
index 08c966a..26bb3d1 100644
--- a/syntax/tokens.rs
+++ b/syntax/tokens.rs
@@ -47,6 +47,7 @@ impl ToTokens for Ty1 {
 impl ToTokens for Ref {
     fn to_tokens(&self, tokens: &mut TokenStream) {
         self.ampersand.to_tokens(tokens);
+        self.lifetime.to_tokens(tokens);
         self.mutability.to_tokens(tokens);
         self.inner.to_tokens(tokens);
     }
@@ -110,6 +111,7 @@ impl Receiver {
 impl ToTokens for ReceiverType<'_> {
     fn to_tokens(&self, tokens: &mut TokenStream) {
         self.0.ampersand.to_tokens(tokens);
+        self.0.lifetime.to_tokens(tokens);
         self.0.mutability.to_tokens(tokens);
         self.0.ty.to_tokens(tokens);
     }
diff --git a/tests/ui/disallow_lifetime.rs b/tests/ui/disallow_lifetime.rs
new file mode 100644
index 0000000..ee39fef
--- /dev/null
+++ b/tests/ui/disallow_lifetime.rs
@@ -0,0 +1,13 @@
+#[cxx::bridge]
+mod ffi {
+    extern "C" {
+        type C;
+        fn f(&'static self);
+    }
+
+    extern "Rust" {
+        fn f(string: &'a String);
+    }
+}
+
+fn main() {}
diff --git a/tests/ui/disallow_lifetime.stderr b/tests/ui/disallow_lifetime.stderr
new file mode 100644
index 0000000..d7c42e4
--- /dev/null
+++ b/tests/ui/disallow_lifetime.stderr
@@ -0,0 +1,11 @@
+error: references with explicit lifetimes are not supported
+ --> $DIR/disallow_lifetime.rs:9:22
+  |
+9 |         fn f(string: &'a String);
+  |                      ^^^^^^^^^^
+
+error: references with explicit lifetimes are not supported
+ --> $DIR/disallow_lifetime.rs:5:14
+  |
+5 |         fn f(&'static self);
+  |              ^^^^^^^^^^^^^

